/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "MidiGMFromMT32Mapper.h"

int MidiGMFromMT32Mapper::getInstrument(int instr)
{
  /* MT-32 emulation translate table */
  
  static int mt32pgm[128] =
  {
    0,   1,   2,   4,   4,   5,   5,   3,  16,  16,  16,  16,  19,
    19,  19,  21,   6,   6,   6,   7,   7,   7,   8,   8,  62,  57,
    63,  58,  38,  38,  39,  39,  88,  33,  52,  35,  97, 100,  38,
    39,  14, 102,  68, 103,  44,  92,  46,  80,  48,  49,  51,  45,
    40,  40,  42,  42,  43,  46,  46,  24,  25,  28,  27, 104,  32,
    32,  34,  33,  36,  37,  39,  35,  79,  73,  76,  72,  74,  75,
    64,  65,  66,  67,  71,  71,  69,  70,  60,  22,  56,  59,  57,
    63,  60,  60,  58,  61,  61,  11,  11,  99, 100,   9,  14,  13,
    12, 107, 106,  77,  78,  78,  76, 111,  47, 117, 127, 115, 118,
    116, 118, 126, 121, 121,  55, 124, 120, 125, 126, 127
  };

  if (instr >= 128)
    return instr;
  
  return mt32pgm[instr];

}
