/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "MidiFile.h"
#include "MidiDevice.h"
#include <string>

#ifndef _MIDIUTILS_H_
#define _MIDIUTILS_H_

///
class MidiUtils
{

  ///
  static MidiTrackEventIterator* getNextTrackEvent(MidiTrackEventIterator *tracksiter[], int nbtracks);

 public:

  ///
  static void uniquifyTrack(MidiFile *file, vector<pair<unsigned long, MidiEvent*> > &seq);
  ///
  static void extractLyrics( vector<pair<unsigned long, MidiEvent*> > &events, vector<pair<unsigned long, MidiEvent*> > &lyrics);
  ///
  static void extractLyrics( vector<pair<unsigned long, MidiEvent*> > &events, vector<pair<unsigned long, MidiEvent*> > &lyrics, string & language, vector<string> &title, vector<string> &info);
  ///
  static void extractLyrics(MidiFile *midif, vector<pair<unsigned long, MidiEvent*> > &lyrics, string & language, vector<string> &title, vector<string> &info);
  //
  static char *cppstrdup(char const *str);

 private:
  static bool extractLyrics(MidiTrackEventIterator*iter, vector<pair<unsigned long, MidiEvent*> > &lyrics, string & language, vector<string> &title, vector<string> &info, bool getlyrics);

}///
;

#endif
