/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "OSSMidiDevice.h"

void OSSMidiDevice::waitUntil(unsigned long divisions, unsigned long ticks)
{
  ticks -= _tickStart;

  if (divisions>0)
    {

      if (ticks <= _prevTick)
	{
	  return;
	}

      //      unsigned long value = (unsigned long) ((double) ( ticks * (_tempo / _frequenceRatio)) / (double) ((double)divisions));
      //       if (value<=_curt)
      // 	return;
      //       _curt = value;
      //            SEQ_WAIT_TIME( value );


      double ctime = ((double) ( (ticks - _prevTick) * (getTempo() / _frequenceRatio)) / (double) ((double)divisions));

      _prevTime += ctime;
      _prevTick = ticks;

      if ( ((int)ctime) == 0)
	{
	  return;
	}

      //      cout << "wait " << (int)_prevTime << " (" << ticks << ")(" << _tempo << ")" << endl;

      SEQ_WAIT_TIME( (int)_prevTime );


    }
  else if (divisions<0)
    {
      SEQ_WAIT_TIME( ticks / (((divisions&0xff)>>8)*((divisions&0xff)*((int)_frequenceRatio))));
    }
}
