/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "MidiDevice.h"
#include "OSSMidiDevice.h"

#ifndef _SYNTHOSSDEVICE_H_
#define _SYNTHOSSDEVICE_H_

///
class SynthOSSDevice : public OSSMidiDevice
{
 protected:


  ///  int _seq;
  int _activeDevice;
  ///
  int _nbdevices;

 public:
  ///
  SynthOSSDevice(char *filename, int dev);
  
  ///
  virtual void afterTouch(int channel, int note, int velocity);
  ///
  virtual void noteOn(int channel, int note, int velocity);
  ///
  virtual void noteOff(int channel, int note, int velocity);

  ///
  virtual void setVolume(int volume);
  ///
  virtual void sendBender(int channel, int data1);
  ///
  virtual void sendChannelAfterTouch(int channel, int data1);
  ///
  virtual void sendPatchChange(int channel, int data1);
  ///
  virtual void sendControlChange(int channel, int data1, int data2);

  ///
  virtual void terminateAll();

}///
;

#endif
