/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "FontDialogPrefs.h"

static gint fontdialogprefs_ok(GtkWidget *widget, gpointer data)
{
  ((FontDialogPrefs*)data)->ok();
  return TRUE;
}

static gint fontdialogprefs_cancel(GtkWidget *widget, gpointer data)
{
  ((FontDialogPrefs*)data)->cancel();
  return TRUE;
}

static gint fontdialogprefs_delete_event(GtkWidget* widget, GdkEventConfigure* event, gpointer data)
{
  ((FontDialogPrefs*)data)->cancel();
  return TRUE;
}

FontDialogPrefs::FontDialogPrefs(string name) : fontName(name)
{
  fontMain = gtk_font_selection_dialog_new("Lyrics font");
  gtk_font_selection_dialog_set_font_name(GTK_FONT_SELECTION_DIALOG(fontMain), fontName.c_str());
  gtk_signal_connect( GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fontMain)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC( fontdialogprefs_ok ), this);
  gtk_signal_connect( GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fontMain)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC( fontdialogprefs_cancel ), this);
  gtk_signal_connect( GTK_OBJECT(fontMain), "delete_event",
		      GTK_SIGNAL_FUNC( fontdialogprefs_delete_event ), this);
  Visible = false;
}

FontDialogPrefs::~FontDialogPrefs()
{
  gtk_widget_destroy(fontMain);
}

void FontDialogPrefs::show()
{
  if (Visible == false)
    {
      Visible = true;
      gtk_font_selection_dialog_set_font_name(GTK_FONT_SELECTION_DIALOG(fontMain), fontName.c_str());
      gtk_widget_show(fontMain);
    }
}
void FontDialogPrefs::hide()
{
  gtk_widget_hide(fontMain);
  Visible = false;
}

void FontDialogPrefs::ok()
{
  fontName = gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(fontMain));
  hide();
}

void FontDialogPrefs::cancel()
{
  hide();
}

string FontDialogPrefs::getName()
{
  return fontName;
}
