/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef __KARAOKEBASE_H_
#define __KARAOKEBASE_H_

#include "MidnightConfiguration.h"
#include "PlayerInterface.h"
#include <gtk/gtk.h>
#include <iostream.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <vector>
#include <string>

#include "MidiEvent.h"
#include "MidiUtils.h"

class KaraokeBase
{
   PlayerInterface* _guiplayer;

   MidnightConfiguration *_config;

  vector<pair<unsigned long, string> > _text;
  vector<pair<unsigned long, string> >::iterator _lyriter;

 public:
  
  KaraokeBase(PlayerInterface *player);

  virtual ~KaraokeBase() 
    {
      // delete all
    }

  void setGUIPlayer(PlayerInterface *mdngp);

  PlayerInterface* getGUIPlayer();

  virtual bool isShowing() { return false; }
  virtual void show() { }
  virtual void hide() { }

  virtual void ticked(int tick) { }
  
  void clearLyrics();

  virtual void showPreferences() = 0;
  virtual void setStatus(string str) = 0;

  virtual void addLyricUnit(pair<unsigned long, string> lunit);

  virtual void initLyrics();  

  virtual void update(unsigned int tick) { }
  
  int ticksToMs(int ticks)
    {
      return _guiplayer->ticksToMs(ticks);
    }

  void setConfiguration(MidnightConfiguration* config) { _config = config; }
  MidnightConfiguration* getConfiguration() { return _config; }
  
 protected:

  vector<pair<unsigned long, string> >::iterator & findNextEvent(unsigned long tick);
  vector<pair<unsigned long, string> >::iterator & getEventIterator();
  vector<pair<unsigned long, string> >::iterator getEventBegin();
  vector<pair<unsigned long, string> >::iterator getEventEnd();
};

#endif
