/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _PLAYERINTERFACE_H_
#define _PLAYERINTERFACE_H_

#include <string>

class PlayerInterface
{
 public:
  virtual void selectSong(string& filename) = 0;
  virtual void toggleShowListPanel() = 0;
  virtual void toggleShowKaraokePanel() = 0;
  virtual void toggleMenuItem_show_karaoke(bool val) = 0;
  virtual void toggleMenuItem_show_list(bool val) = 0;
  virtual void play() = 0;
  virtual int ticksToMs(int ticks) =0;

  virtual void setFeature(string, string) = 0;
  virtual string getFeature(string, string) = 0;
  virtual void setIntFeature(string, int) = 0;
  virtual int getIntFeature(string, int) = 0;
  virtual void flushConfiguration() = 0;
  virtual void droppedData(const char *data) = 0;
};

#endif
