#include "StringTokenizer.h"


void StringTokenizer::setNext()
{
  if (m_pos>=m_str.size())
    {
      m_hasNext = false;
    }

  for ( ; m_pos < m_str.size(); m_pos++)
    {
      if (m_separator.find(m_str.at(m_pos)) == m_separator.npos)
	{
	  // not a separator !
	      
	  int begin = m_pos;
	      
	  for ( ; (m_pos < m_str.size()); m_pos++)
	    {
	      if (m_separator.find(m_str.at(m_pos)) != m_separator.npos)
		{
		  m_next = string(m_str, begin, m_pos-begin);
		  m_hasNext = true;
		  return;
		}
	    }
	      
	  m_next = string(m_str, begin, m_pos-begin);
	  m_hasNext = true;
	  return;
	}
    }
  m_hasNext = false;
}

StringTokenizer::StringTokenizer(char *str, char *separators) : m_str(str), m_pos(0), m_separator(separators)
{
  setNext();
}


StringTokenizer::StringTokenizer(const string &str, const string &separators) : m_str(str),  m_pos(0), m_separator(separators)
{
  setNext();
}

StringTokenizer::StringTokenizer(char *str) : m_str(str), m_pos(0), m_separator(" \n\t\r")
{
  setNext();
}
StringTokenizer::StringTokenizer(const string &str) : m_str(str), m_pos(0), m_separator(" \n\t\r")
{
  setNext();
}
  
bool StringTokenizer::hasNext() const
{
  return m_hasNext;
}

string StringTokenizer::next()
{
  string result = m_next;
  setNext();
  return result;
}
